From b057f1b4d9e0c201c698e72fbe93e0068a531b03 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Sun, 25 Aug 2019 21:17:54 +0800
Subject: [PATCH] Add libkcapi libraries

---
 3rdparty/libkcapi/build.sh              |  105 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 3rdparty/libkcapi/libkcapi-1.1.5.tar.gz |    0 
 2 files changed, 105 insertions(+), 0 deletions(-)

diff --git a/3rdparty/libkcapi/build.sh b/3rdparty/libkcapi/build.sh
new file mode 100755
index 0000000..8934fe4
--- /dev/null
+++ b/3rdparty/libkcapi/build.sh
@@ -0,0 +1,105 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile libkcapi for ARM
+#|            libkcapi is linux kernel crypto userspace API library, official introduction site:  
+#|    Linux Kernel:  https://www.kernel.org/doc/html/latest/crypto/userspace-if.html
+#|        libkcapi:  http://www.chronox.de/libkcapi.html
+#| 
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PRJ_PATH=`pwd`
+PREFIX_PATH=`pwd`/../install/
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/buildroot/cortex-a5/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+
+function compile_libkcapi()
+{
+    SRC_NAME=libkcapi-1.1.5
+    PACK_SUFIX=tar.gz
+
+    if [ -f ${PREFIX_PATH}/lib/libkcapi.a ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        wget https://codeload.github.com/smuellerDD/libkcapi/tar.gz/v1.1.5 -O ${SRC_NAME}.${PACK_SUFIX}
+        #wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    export CFLAGS=" -I${PREFIX_PATH}/include" 
+    export CPPFLAGS=" -I${PREFIX_PATH}/include" 
+    export LDFLAGS=" -L${PREFIX_PATH}/lib" 
+
+    autoreconf -i
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --enable-static  --enable-shared --enable-kcapi-test  \
+        --enable-kcapi-rngapp 
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    make && make install
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+    cd -
+}
+
+export_cross
+
+compile_libkcapi
+
+
+
diff --git a/3rdparty/libkcapi/libkcapi-1.1.5.tar.gz b/3rdparty/libkcapi/libkcapi-1.1.5.tar.gz
new file mode 100644
index 0000000..d4e7995
--- /dev/null
+++ b/3rdparty/libkcapi/libkcapi-1.1.5.tar.gz
Binary files differ

--
Gitblit v1.9.1